<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11) on Wed Mar 13 11:46:20 CET 2019 -->
<title>UniqueNumbers</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta name="dc.created" content="2019-03-13">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="UniqueNumbers";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":9,"i1":9,"i2":9,"i3":9,"i4":9,"i5":9,"i6":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/UniqueNumbers.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">hr.fer.zemris.java.hw01</a></div>
<h2 title="Class UniqueNumbers" class="title">Class UniqueNumbers</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>hr.fer.zemris.java.hw01.UniqueNumbers</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">UniqueNumbers</span>
extends java.lang.Object</pre>
<div class="block">Class <code>UniqueNumbers</code> enables creation of a sorted binary tree with unique elements (cannot have duplicate tree node values).
 Also, the class provides information about its size and check of particular elements' presence.</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>1.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd>Leo Plese</dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="nested.class.summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="memberSummary">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Class</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>(package private) static class&nbsp;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a></span></code></th>
<td class="colLast">
<div class="block">Class <code>TreeNode</code> representing model of a tree node which has its <code>value</code> and two children - <code>left</code> and <code>right</code>.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">UniqueNumbers</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>static <a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addNode(hr.fer.zemris.java.hw01.UniqueNumbers.TreeNode,int)">addNode</a></span>&#8203;(<a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;node,
       int&nbsp;value)</code></th>
<td class="colLast">
<div class="block">Method adding a new node to the tree if the value is not already present in it.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>static boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#containsValue(hr.fer.zemris.java.hw01.UniqueNumbers.TreeNode,int)">containsValue</a></span>&#8203;(<a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;node,
             int&nbsp;value)</code></th>
<td class="colLast">
<div class="block">Method checking if a particular value is present in any node of a given tree.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>private static <a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#enterNodeValues(java.util.Scanner,hr.fer.zemris.java.hw01.UniqueNumbers.TreeNode)">enterNodeValues</a></span>&#8203;(java.util.Scanner&nbsp;sc,
               <a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;head)</code></th>
<td class="colLast">
<div class="block">Method enables user to input values to be added to the tree.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getNodesAscending(hr.fer.zemris.java.hw01.UniqueNumbers.TreeNode,java.lang.String)">getNodesAscending</a></span>&#8203;(<a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;node,
                 java.lang.String&nbsp;message)</code></th>
<td class="colLast">
<div class="block">Method creating string containing tree node values in ascending order.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>static java.lang.String</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getNodesDescendingFromAscending(java.lang.String)">getNodesDescendingFromAscending</a></span>&#8203;(java.lang.String&nbsp;valuesAscending)</code></th>
<td class="colLast">
<div class="block">Method creating string containing tree node values in ascending order.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>static void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#main(java.lang.String...)">main</a></span>&#8203;(java.lang.String...&nbsp;args)</code></th>
<td class="colLast">
<div class="block">Main method calling additional methods to realize user interaction so as to get the user input and add the input values to the tree under the restriction that elements have to be unique.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>static int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#treeSize(hr.fer.zemris.java.hw01.UniqueNumbers.TreeNode)">treeSize</a></span>&#8203;(<a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;node)</code></th>
<td class="colLast">
<div class="block">Method calculating a tree's size i.e.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>UniqueNumbers</h4>
<pre>public&nbsp;UniqueNumbers()</pre>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="main(java.lang.String...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>main</h4>
<pre class="methodSignature">public static&nbsp;void&nbsp;main&#8203;(java.lang.String...&nbsp;args)</pre>
<div class="block">Main method calling additional methods to realize user interaction so as to get the user input and add the input values to the tree under the restriction that elements have to be unique.
 Finally, it provides the output listing the tree node values in ascending and descending order.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>args</code> - input arguments not used in this program</dd>
</dl>
</li>
</ul>
<a id="enterNodeValues(java.util.Scanner,hr.fer.zemris.java.hw01.UniqueNumbers.TreeNode)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>enterNodeValues</h4>
<pre class="methodSignature">private static&nbsp;<a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;enterNodeValues&#8203;(java.util.Scanner&nbsp;sc,
                                                      <a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;head)</pre>
<div class="block">Method enables user to input values to be added to the tree.
 
 Important restrictions (ensured by calling appropriate methods):
 - the user-input values must be of type specified in <code>TreeNode</code> (<code>int</code>)
 - the same input must not be added to the tree as a new node more than ones</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>sc</code> - <code>Scanner</code> object used for user console interaction</dd>
<dd><code>head</code> - tree's head node further elements are added to</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>head node after adding all the input nodes with values from user input</dd>
</dl>
</li>
</ul>
<a id="getNodesAscending(hr.fer.zemris.java.hw01.UniqueNumbers.TreeNode,java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getNodesAscending</h4>
<pre class="methodSignature">public static&nbsp;java.lang.String&nbsp;getNodesAscending&#8203;(<a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;node,
                                                 java.lang.String&nbsp;message)</pre>
<div class="block">Method creating string containing tree node values in ascending order.
 Based on the recursive algorithm.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - tree's head node</dd>
<dd><code>message</code> - input string further values are concatenated to (to be set to an empty string in method call)</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>string representing values of tree nodes in ascending order</dd>
</dl>
</li>
</ul>
<a id="getNodesDescendingFromAscending(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getNodesDescendingFromAscending</h4>
<pre class="methodSignature">public static&nbsp;java.lang.String&nbsp;getNodesDescendingFromAscending&#8203;(java.lang.String&nbsp;valuesAscending)</pre>
<div class="block">Method creating string containing tree node values in ascending order.
 The algorithm is based on the input string <code>valuesAscending</code> being reversed to get the opposite order of tree node values (from ascending to descending).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>valuesAscending</code> - string representing values of tree nodes in ascending order</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>string representing values of tree nodes in descending order</dd>
</dl>
</li>
</ul>
<a id="addNode(hr.fer.zemris.java.hw01.UniqueNumbers.TreeNode,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addNode</h4>
<pre class="methodSignature">public static&nbsp;<a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;addNode&#8203;(<a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;node,
                                             int&nbsp;value)</pre>
<div class="block">Method adding a new node to the tree if the value is not already present in it.
 Based on the recursive algorithm.
 
 Important: the new node is being added as in a sorted binary tree (nodes with value less than their parent's go to the parent's left, otherwise to the right)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - tree's head node</dd>
<dd><code>value</code> - value to be added to a new node to the tree</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>tree node added to the tree</dd>
</dl>
</li>
</ul>
<a id="treeSize(hr.fer.zemris.java.hw01.UniqueNumbers.TreeNode)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>treeSize</h4>
<pre class="methodSignature">public static&nbsp;int&nbsp;treeSize&#8203;(<a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;node)</pre>
<div class="block">Method calculating a tree's size i.e. counting the number of nodes in the tree.
 Based on the recursive algorithm.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - tree's head node</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>size of a tree (number of nodes in the tree)</dd>
</dl>
</li>
</ul>
<a id="containsValue(hr.fer.zemris.java.hw01.UniqueNumbers.TreeNode,int)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>containsValue</h4>
<pre class="methodSignature">public static&nbsp;boolean&nbsp;containsValue&#8203;(<a href="UniqueNumbers.TreeNode.html" title="class in hr.fer.zemris.java.hw01">UniqueNumbers.TreeNode</a>&nbsp;node,
                                    int&nbsp;value)</pre>
<div class="block">Method checking if a particular value is present in any node of a given tree.
 It is used to determined whether the restriction of unique numbers in the tree is fulfilled.
 Based on the recursive algorithm.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>node</code> - tree's head node</dd>
<dd><code>value</code> - value whose presence in a given tree is to be tested</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the tree already contains value</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/UniqueNumbers.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
